#ifndef _AiCmds_
#define _AiCmds_

enum AiCommand {
	CMD_NONE,
	CMD_SELECT,
	CMD_STOP,
	CMD_GO,
	CMD_ATTACK,
	CMD_FOLLOW,
	CMD_FORMATION,
	CMD_PICKUP,
	CMD_DROPOFF,
	CMD_UNDEPLOY,
	CMD_DEPLOY,
	CMD_NO_DEPLOY,
	CMD_GET_REPAIR,
	CMD_GET_RELOAD,
	CMD_GET_WEAPON,
	CMD_GET_CAMERA,
	CMD_GET_BOMB,
	CMD_DEFEND,
	CMD_RESCUE,
	CMD_RECYCLE,
	CMD_SCAVENGE,
	CMD_HUNT,
	CMD_BUILD,
	CMD_PATROL,
	CMD_STAGE,
	CMD_SEND,
	CMD_GET_IN,
	CMD_LAY_MINES,
	CMD_LOOK_AT,
	CMD_SERVICE,
	CMD_UPGRADE,
	CMD_DEMOLISH,
	CMD_POWER,
	CMD_BACK,
	CMD_DONE,
	CMD_CANCEL,
	CMD_SET_GROUP,
	CMD_SET_TEAM,
	CMD_SEND_GROUP,
	CMD_TARGET,
	CMD_INSPECT,
	CMD_SWITCHTEAM,
	CMD_INTERFACE,
	CMD_LOGOFF,
	CMD_AUTOPILOT,
	CMD_MESSAGE,
	CMD_CLOSE,
	CMD_MORPH_SETDEPLOYED, // For morphtanks
	CMD_MORPH_SETUNDEPLOYED, // For morphtanks
	CMD_MORPH_UNLOCK, // For morphtanks
	CMD_BAILOUT,
	CMD_BUILD_ROTATE, // Update building rotations by 90 degrees.
	NUM_CMD
}; // Don't let NUM_COMMAND go past 255, as 1 byte is used for it when sending across network

#endif
